package vishnu.testvis.dendro;

import java.util.*;

// kainof DistanceMatrix
public class SimMatrix
{
  public double[] matrix;

  // "vectors" is the expanded SparseMatrix, i.e. doc x keywords
  // VECTOR_SIZE = #keywords
  public SimMatrix(double[][] vectors,
      int limit, Distance simfunc, int VECTOR_SIZE)
  {
    int i,j;
    double iarray[];
    
    // size = #docs
    int size=vectors.length, index=0;
    
    // to exclude diagonal and conjugates
    // - - - - -
    //         |
    // *       |
    // * *     |
    // * * *   |    
    int realSize = (size * (size - 1)/2);
    matrix=new double[realSize];
    System.out.println("Similarity matrix size: " + size);
    
    for(i = 1; i < size; i++)
    {
        iarray=vectors[i];
        for(j = 0; j < i; j++)
        {
            matrix[index] = simfunc.get(iarray,
                            vectors[j],
                            VECTOR_SIZE);
	        index++;
        }
    }
  }

}


