package org.greenstone.gsdl3.gs3build.metadata;

import java.io.File;
import java.net.URL;
import java.net.URLConnection;

import org.greenstone.gsdl3.gs3build.util.URLTools;

public class METSLocation
{
  String type;
  URL    location;

  public METSLocation(String type, String location) throws java.net.MalformedURLException
  { this.type = type;
    this.location = new URL(location);
  }

  public METSLocation(URL url)
  { this.type = "URL";
    this.location = url;
  }

  public METSLocation(File file)
  { this.type = "URL";
    this.location = URLTools.getFileURL(file);
  }

  public boolean equals(URL url)
  { return this.location.equals(url);
  }

  public URL getLocation()
  { return this.location;
  }

  public long getModifiedDatestamp()
  { if (this.location != null) {
      if (this.location.getProtocol().equals("file")) {
	File file = new File(this.location.getPath());
	return file.lastModified();
      }
      else {
	try {
	  URLConnection connection = this.location.openConnection();
	  return connection.getLastModified();
	}
	catch (java.io.IOException io)
	{ // TODO: report error
	}
      }
    }
    return System.currentTimeMillis();
  }

  public String getType()
  { return this.type;
  }
}
